﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data.OleDb
Imports C1.Win.Chart
Public Class Form1
    Dim dt As DataTable = New DataTable()
    Private npts As Integer = 50
    Private rnd As Random = New Random()
    Private trendLine As C1.Win.Chart.TrendLine
    Private dataList As ObservableCollection(Of DataItem) = New ObservableCollection(Of DataItem)()

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim sql As String = "select * from Orders"
        Dim conn As String = GetConnectionString()
        Dim da As New OleDbDataAdapter(sql, conn)
        da.Fill(dt)
        SetupChart()
    End Sub
    Private Sub SetupChart()
        Dim data = New DataItem(npts - 1) {}
        Dim dateStep = 0
        For i = 0 To npts - 1
            dateStep += 1
            Dim date1 = DateTime.Today.AddDays(dateStep + 9)
            data(i) = New DataItem() With
                        {
                            .Downloads = If(date1.Month = 4 OrElse date1.Month = 8, CType(Nothing, Integer?), rnd.[Next](10, 20)),
                            .Sales = If(date1.Month = 4 OrElse date1.Month = 8, CType(Nothing, Integer?), rnd.[Next](0, 10)),
                            .DateField = date1
                        }
        Next

        FlexChart1.BeginUpdate()
        FlexChart1.ChartType = C1.Chart.ChartType.Line
        FlexChart1.Series.Clear()
        FlexChart1.BindingX = "DateField"
        Dim rnt = New Random()
        For i As Integer = 1 To 11 - 1
            dataList.Add(New DataItem() With {.X = DateTime.Today.AddDays(i + 30), .Y = rnt.[Next](2, 30)})
        Next

        trendLine = New C1.Win.Chart.TrendLine() With
            {
            .Name = "Trend line",
            .DataSource = dataList,
            .Binding = "Y",
            .BindingX = "X",
            .Order = 8
            }
        FlexChart1.Series.Add(New Series() With {.Name = "Downloads", .Binding = "Downloads"})
        '    FlexChart1.Series.Add(New Series() With {.Name = "Sales", .Binding = "Sales"})
        FlexChart1.Series.Add(trendLine)
        FlexChart1.DataSource = data
        FlexChart1.AxisX.LabelAngle = -40
        FlexChart1.EndUpdate()
    End Sub
    Private Shared Function GetConnectionString() As String
        Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\ComponentOne Samples\Common"
        Dim conn As String = "provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;"
        Return String.Format(conn, path)
    End Function
    Public Class DataItem
        Implements INotifyPropertyChanged

        Public Property Downloads As Integer?

        Public Property Sales As Integer?

        Public Property DateField As DateTime

        Private _y As Integer

        Public Property X As DateTime

        Public Property Y As Integer
            Get
                Return _y
            End Get

            Set(ByVal value As Integer)
                If value = _y Then Return
                _y = value
                OnPropertyChanged("Y")
            End Set
        End Property

        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

        Protected Overridable Sub OnPropertyChanged(ByVal propertyName As String)
            'Dim handler = PropertyChanged
            'RaiseEvent handler(Me, New PropertyChangedEventArgs(propertyName))
        End Sub
    End Class
End Class
